<?php

namespace Nest\Types\Exceptions;

use Throwable;

/**
 * Exception thrown when a given type is incompatible (a required interface is not implemented).
 */
class IncompatibleTypeException extends TypeException
{
	/**
	 * @param string $typeClass Incompatible type class.
	 * @param string $compatibilityInterface Not implemented interface.
	 * @param int $code [optional] The Exception code.
	 * @param null|Throwable $previous [optional] The previous throwable used for the exception chaining.
	 */
	public function __construct(public string $typeClass, public string $compatibilityInterface, int $code = 0, ?Throwable $previous = null)
	{
		parent::__construct("$this->typeClass does not implement required compatibility interface: $this->compatibilityInterface", $code, $previous);
	}
}
