<?php

namespace Nest\Types\Exceptions;

use Nest\Types\Type;
use Throwable;

/**
 * Exception for an invalid deserialized value given to serialize.
 */
class ValueNotSerializableException extends TypeException
{
	public function __construct(public Type $type, public mixed $value, ?Throwable $previous = null)
	{
		parent::__construct("Cannot serialize value of type ".get_debug_type($this->value)." to ".get_class($this->type), previous: $previous);
	}
}
